<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { IsMobileMixin } from '../../mixins';
import {
  Faq as FAQ,
  NextStepAlt,
  Modal as SlpModal,
} from '~/components/common/index.vue';
import {
  Addons,
  FeatureComparison,
  NextSteps,
  PricingTiersToggle,
} from '~/components/pricing/index.vue';
import { getPageMetadata } from '~/common/meta';

const parseToKebabCase = (string: string) => {
  return string
    .toLowerCase()
    .replaceAll('?', '')
    .replace(/[&/\\#,+()$~%.'":*?<>{}\s]/g, '-');
};

export default Vue.extend({
  components: {
    FAQ,
    NextSteps,
    SlpModal,
    Addons,
    NextStepAlt,
    FeatureComparison,
    PricingTiersToggle,
  },
  mixins: [IsMobileMixin],
  layout: 'no-banner',
  async asyncData({ $pricingService, $content, i18n }: any) {
    try {
      const locale = i18n.locale;
      const data = await $content(locale, 'pricing/index').fetch();
      const content = await $pricingService.getPricingPageContent(i18n);

      return { content, data, locale };
    } catch (e) {
      throw new Error(e);
    }
  },
  data() {
    return {
      activeCarouselIndex: 1,
      isModalOpen: false,
      modalPlan: {},
      audience: '',
      sections: [],
      activeHeader: '',
      isSelfManaged: false,
      sixSenseData: {},
    };
  },
  head(): MetaInfo {
    return getPageMetadata(
      {
        ...this.content,
        schema_org: this.data?.schema_org,
        schema_faq: this.data?.schema_faq,
      },
      this.$route.path,
      this.$nuxtI18nHead({ addSeoAttributes: true }),
    );
  },
  beforeMount() {
    this.getData();
  },
  mounted() {
    this.removeNavForPathFactory();
    this.sections = this.content?.faq?.groups?.map(({ header, id }) => {
      return {
        header,
        id: id || (header && parseToKebabCase(header)),
        dataGaName: id || (header && parseToKebabCase(header)),
        dataGaLocation: 'pricing-faq',
      };
    });

    window.addEventListener('load', () => {
      const queryParams = this.$route.query;
      if (
        Object.prototype.hasOwnProperty.call(
          queryParams,
          'override-enterprise',
        ) ||
        Object.prototype.hasOwnProperty.call(queryParams, 'override-smb')
      ) {
        if (
          queryParams['override-enterprise'] ||
          queryParams['override-enterprise'] === null
        ) {
          this.audience = 'gold-ultimate';
        } else if (
          queryParams['override-smb'] ||
          queryParams['override-smb'] === null
        ) {
          this.audience = 'silver-premium';
        }
      } else {
        this.getUserAudience();
      }
    });
  },
  methods: {
    // Because of timing, this can't happen in asyncData() or fetch()
    async getData() {
      this.sixSenseData = await fetch(
        'https://epsilon.6sense.com/v3/company/details',
        {
          method: 'GET',
          headers: {
            Authorization: `Token 715ff02645f8e09a174845255d544dac8c178c02`,
          },
        },
      ).then((res) => {
        return res.json();
      });
    },
    focusedId(id) {
      const section = this.sections.find((s) => s.id === id);
      this.activeHeader = section.header;
    },
    carouselGoTo(index: number): void {
      const carouselRef = this.$refs.carousel as any;
      this.activeCarouselIndex = index;
      if (carouselRef.goTo) {
        carouselRef.goTo(index);
      }
    },
    handleCarouselChange(index: number): void {
      this.activeCarouselIndex = index;
    },
    openModal(plan: object) {
      this.isModalOpen = true;
      this.modalPlan = plan;
    },
    closeModal() {
      this.isModalOpen = false;
    },
    removeNavForPathFactory() {
      const windowURL = window.location.search;
      if (windowURL.includes('menu=hide') && window.self !== window.top) {
        document.querySelector<HTMLElement>('footer.footer')!.style.display =
          'none';
        document.querySelector<HTMLElement>('.navigation')!.style.display =
          'none';
      }
    },
    getUserAudience() {
      const employeeCount = Number(this.sixSenseData.company.employee_count);

      if (this.sixSenseData) {
        window.SixSenseData = this.sixSenseData;
        if (employeeCount) {
          this.audience =
            employeeCount >= 100 ? 'gold-ultimate' : 'silver-premium';
        }
      }
    },
    onToggleChance(id) {
      this.isSelfManaged = id === 'self-managed';
    },
  },
});
</script>

<template>
  <div class="pricing-container">
    <SlpContainer
      v-if="data.banner"
      class="pricing-promo"
      :class="{ 'pricing-promo--nonEnglish': locale }"
      variant="light-purple-100"
    >
      <SlpRow class="pricing-promo__content">
        <SlpTypography tag="p" variant="body2-bold">
          {{ data.banner?.title }}
        </SlpTypography>
        <SlpButton
          :href="data.banner?.primary_button?.href"
          variant="tertiary"
          class="pricing-promo__cta"
          :data-ga-name="data.banner?.primary_button?.data_ga_name"
          :data-ga-location="data.banner?.primary_button?.data_ga_location"
        >
          {{ data.banner?.primary_button?.text }}
          <SlpIcon variant="product" name="arrow-right" />
        </SlpButton>
      </SlpRow>
    </SlpContainer>
    <SlpContainer class="carousel-container">
      <div class="header-container">
        <SlpTypography tag="h1" variant="heading1-bold" class="slp-mb-16">
          {{ data.heading }}
        </SlpTypography>
      </div>
      <PricingTiersToggle
        :data="data.plans_by_type"
        :audience="audience"
        @active-toggle-id="onToggleChance"
      />

      <p class="subtitle">{{ data.subtitle }}</p>
    </SlpContainer>
    <SlpContainer>
      <FeatureComparison
        :plans="data.plans_by_type[0].tiers"
        :data="data.feature_comparison"
        @planSelect="(event) => openModal(event)"
      />
    </SlpContainer>
    <SlpContainer>
      <Addons
        v-if="content.addons"
        :data="content.addons"
        :is-self-managed="isSelfManaged"
      />
    </SlpContainer>
    <section>
      <NextSteps v-if="content.next_steps" :data="content.next_steps" />
    </section>
    <section>
      <SlpSectionsNavigator
        v-if="sections"
        :sections="sections"
        class="pricing-promo__section-navigator"
        :class="{ 'pricing-promo__section-navigator--nonEnglish': locale }"
        @focusedId="focusedId"
      />
      <SlpContainer variant="light-purple-100">
        <FAQ
          v-if="content.faq && content.faq.header"
          :data="content.faq"
          :active-header="activeHeader"
          data-aos="fade-right"
          data-aos-duration="800"
          :has-jump-down="false"
          class="pricing-promo__faq"
          :sticky-top="locale ? 200 : 240"
        />
      </SlpContainer>
    </section>
    <NextStepAlt />

    <slp-modal v-if="isModalOpen" @close="closeModal">
      <div class="buy-modal">
        <div class="modal-header">
          <SlpTypography tag="h3" variant="heading3-bold">{{
            data.modal_content.header
          }}</SlpTypography>
        </div>
        <div class="types-container">
          <div class="plan-type saas">
            <SlpTypography tag="h3" variant="heading4">
              {{ data.modal_content.saas.header }}</SlpTypography
            >
            <SlpTypography tag="p" variant="body2">
              {{ data.modal_content.saas.subtitle }}</SlpTypography
            >
            <SlpTypography tag="p" variant="body1" class="experience-notice">
              {{ data.modal_content.saas.experience_notice }}</SlpTypography
            >
            <SlpTypography tag="p" variant="body2" class="description">
              {{ data.modal_content.saas.description }}
            </SlpTypography>
            <div class="purchase-button">
              <SlpButton
                :class="modalPlan.id === 'free' ? 'saas-button' : ''"
                variant="primary"
                :href="modalPlan.links.hosted.url"
                :data-ga-location="`${modalPlan.id}-modal`"
                :data-ga-name="modalPlan.links.hosted.cta_text"
                >{{ modalPlan.links.hosted.cta_text }}</SlpButton
              >
            </div>
          </div>
          <div class="plan-type self-managed">
            <SlpTypography tag="h3" variant="heading4">
              {{ data.modal_content.self_managed.header }}</SlpTypography
            >
            <SlpTypography tag="p" variant="body2">
              {{ data.modal_content.self_managed.subtitle }}</SlpTypography
            >
            <SlpTypography tag="p" variant="body1" class="experience-notice">
              {{
                data.modal_content.self_managed.experience_notice
              }}</SlpTypography
            >
            <SlpTypography tag="p" variant="body2" class="description">
              {{ data.modal_content.self_managed.description }}
            </SlpTypography>
            <div class="purchase-button">
              <SlpButton
                :class="modalPlan.title === 'Free' ? 'install-button' : ''"
                :data-ga-name="modalPlan.links.self_managed.cta_text"
                :data-ga-location="`${modalPlan.id}-modal`"
                :href="modalPlan.links.self_managed.url"
                >{{ modalPlan.links.self_managed.cta_text }}</SlpButton
              >
            </div>
          </div>
        </div>
      </div>
    </slp-modal>
  </div>
</template>

<style lang="scss">
// Allowing overflow in carousel component to prevent tooltips from being cut
.slick-list {
  overflow: visible !important;
}
</style>

<style lang="scss" scoped>
.pricing-container {
  // Added for the AOS animations, the components are initially displaced with an opacity of 0, which causes them to move outside the container
  // creating a horizontal scrollbar in mobile
  .carousel-container {
    @media (max-width: $breakpoint-lg) {
      overflow: hidden;
    }
    .header-container {
      max-width: 700px;
      margin-top: $spacing-64;
      @media (max-width: $breakpoint-md) {
        max-width: inherit;
        margin: $spacing-32 $spacing-16 0;
      }
    }
  }
}

.tiers-section {
  &:deep .slick-dots {
    bottom: -23px;
  }
}

.buy-modal {
  padding: $spacing-32 40px;
  display: flex;
  flex-direction: column;
  .modal-header {
    margin-bottom: $spacing-24;
    text-align: center;
  }
  .types-container {
    display: flex;
    justify-content: center;
    @media (max-width: $breakpoint-lg) {
      flex-direction: column;
      align-items: center;
    }

    .plan-type {
      display: flex;
      flex-direction: column;
      align-items: center;
      padding: $spacing-24 0;
      min-width: 275px;
      max-width: 300px;
      text-align: center;
      &.saas {
        padding-right: 1rem;
        border-right: 1px solid #d7d7d7;
        @media (max-width: $breakpoint-lg) {
          border-bottom: 1px solid #d7d7d7;
          border-top: 1px solid #d7d7d7;
          border-right: none;
          padding-bottom: 24px;
          margin-bottom: 24px;
          padding-right: 0;
        }
      }

      &.self-managed {
        padding-left: 1rem;
        @media (max-width: $breakpoint-lg) {
          padding-left: 0;
        }
      }
      .experience-notice {
        font-weight: 600;
        margin-top: 1rem;
      }
      .description {
        margin-bottom: 1rem;
      }
      .purchase-button {
        width: 100%;
        margin-top: auto;
        justify-content: center;
      }
      .slp-button-secondary {
        background-color: #9b51e0;
      }
    }
  }
}

div.slp-col-md.column {
  height: 100%;
  padding: 0 $spacing-8;
  position: relative;
  width: 366px;
  max-width: 366px;

  &.free-container {
    z-index: 2;
  }
  &.silver-premium-container {
    z-index: 1;
  }
  &.gold-ultimate-container {
    z-index: 0;
  }

  @media (min-width: $breakpoint-sm) and (max-width: $breakpoint-lg) {
    width: 331px;
    max-width: 331px;
  }

  @media (max-width: $breakpoint-sm) {
    width: 286px;
    max-width: 286px;
  }
}

div.carousel-container {
  margin-bottom: $spacing-96;
  @media (max-width: $breakpoint-lg) {
    padding-right: 0;
    padding-left: 0;
  }
}

.carousel-controls {
  display: flex;
  width: 100%;
  justify-content: space-around;
  height: 42px;
  margin-top: $spacing-24;
  button {
    border: none;
    width: 100%;
    border-bottom: 1px solid transparent;
    opacity: 0.2;
    color: $color-primary-200;
    &.active {
      border-bottom: 1px solid #171321;
      opacity: 1;
    }
  }
}

.tiers {
  margin: $spacing-24 auto;
  justify-content: space-between;

  @media (max-width: $breakpoint-lg) {
    margin: $spacing-16 auto;
  }

  .tier {
    text-align: left;
    border-radius: $border-radius-4;
    border-style: solid;
    border: 1px solid transparent;
    padding: $spacing-24;
    margin: 0 auto $spacing-32;
    min-height: 322px;
    @media (min-width: $breakpoint-sm) {
      min-height: 432px;
    }
    @media (min-width: $breakpoint-lg) {
      min-height: 380px;
    }

    .tier-pill {
      background-color: $color-accent-500;
      color: $color-text-50;
      position: absolute;
      padding: $spacing-8 $spacing-16;
      border-radius: 20px;
      top: -17px;
    }

    &.plan-free {
      background-color: $color-surface-100;
      .asterisk {
        vertical-align: top;
      }
      button,
      a {
        padding-left: 0;
      }
      @media (max-width: $breakpoint-sm) {
        .description {
          margin-bottom: $spacing-32;
        }
      }
    }
    &.plan-silver-premium {
      background-color: $color-surface-900;

      &.active {
        border: 2px solid $color-accent-500;
      }
    }

    &.plan-gold-ultimate {
      border-radius: 4px 4px 100px 4px;
      background: url('/nuxt-images/backgrounds/ultimate_tier_gradient.png');
      border: 1px solid $color-surface-900;
      background-size: cover;
      background-repeat: no-repeat;
      background-position: center center;

      &.active {
        border: 2px solid $color-accent-500;
      }

      @media (max-width: $breakpoint-lg) {
        border-radius: 4px 4px 70px 4px;
      }
    }
  }

  .content {
    height: 100%;

    .description {
      margin-bottom: $spacing-8;
    }

    .price-detail-container {
      display: flex;
      flex-direction: row;
      margin-bottom: $spacing-16;

      &__detail {
        display: flex;
        flex-direction: column;
        justify-content: center;
        margin-left: 8px;
      }

      .price-wrapper {
        display: flex;

        @media (max-width: $breakpoint-lg) {
          flex-direction: column;
        }
      }

      .price-container {
        display: flex;
        margin-right: $spacing-8;

        .dollar-sign {
          position: relative;
          top: 15px;

          @media (max-width: $breakpoint-lg) {
            position: initial;
          }
        }
      }
    }
  }
}

.card {
  a {
    font-weight: $font-weight-bold;
    color: $color-text-link-100;
    font-size: $text-body-2;
  }

  h3 {
    margin-bottom: $spacing-16;
  }
}

.pricing-promo {
  padding: 16px 0px;
  position: sticky;
  z-index: 999;

  &--nonEnglish {
    position: initial;
  }

  @media (max-width: $breakpoint-md) {
    top: 80px;
  }

  @media (max-width: $breakpoint-sm) {
    top: 116px;
  }

  @media (min-width: $breakpoint-lg) {
    top: 120px;
  }

  @media (min-width: 1108px) {
    top: 100px;
  }

  @media (min-width: 1184px) {
    top: 84px;
  }

  &__content {
    gap: 16px;
    justify-content: center;
  }

  &__faq {
    padding-top: 24px;
  }

  &__cta {
    font-size: 16px;
    text-decoration: underline;
    padding: 0px;
    font-weight: 400;
  }

  &__section-navigator {
    top: 120px;

    @media (min-width: $breakpoint-md) {
      top: 142px;
    }

    &--nonEnglish {
      top: 116px;

      @media (min-width: $breakpoint-md) {
        top: 84px;
      }
    }
  }
}
</style>
